﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace RowIndexGrid
{
    public partial class Form1 : Form
    {
        int row, filindex, counter;
        string[] rowindex;
        string[] filtercol;
        string[] filteredindexes;
        bool filter,filterdone;
        
        
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable("Table1");

            DataColumn dc1 = new DataColumn("ID",typeof(string));
            DataColumn dc2 = new DataColumn("Name", typeof(string));

            dt.Columns.Add(dc1);
            dt.Columns.Add(dc2);

            for (int i = 0; i < 5; i++)
            {
                DataRow dr = dt.NewRow();
                dr[0] = (i + 10);
                dr[1] = "Name" + (i + 10).ToString();
                dt.Rows.Add(dr);

                DataRow dr1 = dt.NewRow();
                dr1[0] = (i + 20);
                dr1[1] = "Name" + (i + 10).ToString();
                dt.Rows.Add(dr1);
            }

            c1TrueDBGrid1.DataSource = dt;

            
            // 隐藏默认的数据选中标志
            this.c1TrueDBGrid1.RecordSelectors = false;

            // 添加非绑定行
            C1.Win.C1TrueDBGrid.C1DataColumn Col = new C1.Win.C1TrueDBGrid.C1DataColumn();
            C1.Win.C1TrueDBGrid.C1DisplayColumn dc;
            c1TrueDBGrid1.Columns.Insert(0, Col);
            Col.Caption = "";
            dc = c1TrueDBGrid1.Splits[0].DisplayColumns[""];

            // 将新添加的列移动到表格的左边
            c1TrueDBGrid1.Splits[0].DisplayColumns.RemoveAt(this.c1TrueDBGrid1.Splits[0].DisplayColumns.IndexOf(dc));
            c1TrueDBGrid1.Splits[0].DisplayColumns.Insert(0, dc);
            dc.Visible = true;

            dc.Width = this.c1TrueDBGrid1.RecordSelectorWidth;
            dc.Style.BackColor = this.c1TrueDBGrid1.RecordSelectorStyle.BackColor;
            dc.Locked = false;
            dc.AllowFocus = false;
            c1TrueDBGrid1.Rebind(true);

            // 设置 OwnerDraw 属性为 True，以便于在 OwnerDrawCell 事件中完成单元格自绘操作
            this.c1TrueDBGrid1.Splits[0].DisplayColumns[0].OwnerDraw = true;



            // 处理OwnerDrawCell 事件
            this.c1TrueDBGrid1.OwnerDrawCell += (ss, ee) =>
            {
                if (ee.Row == row)
                    ee.Style.BackgroundImage = Image.FromFile(@"..\..\Images\Rec_Sel.png");
            };

            c1TrueDBGrid1.AllowSort = true;
            c1TrueDBGrid1.AllowFilter = true;
            c1TrueDBGrid1.FilterBar = true;
            
        }

    private void c1TrueDBGrid1_UnboundColumnFetch(object sender, C1.Win.C1TrueDBGrid.UnboundColumnFetchEventArgs e)
    {
        if (e.Row == row)
        {
            e.Value = "";
        }
        else
        {
            if (!filter)
            {
                e.Value = (e.Row + 1).ToString();
            }
            else
            {
                if (!filterdone)
                {
                    counter++;
                    for (int i = filindex; i < filtercol.Length; i++)
                    {
                           
                        if (filtercol[i] == c1TrueDBGrid1.Columns[c1TrueDBGrid1.Col].FilterText || filtercol[i].StartsWith(c1TrueDBGrid1.Columns[c1TrueDBGrid1.Col].FilterText))
                        {
                            e.Value = rowindex[i];
                            filindex = i + 1;
                            filteredindexes[counter - 1] = rowindex[i];
                            break;
                        }
                    }
                    if (counter == c1TrueDBGrid1.RowCount)
                    {
                        counter = 0;
                        filterdone = true;
                    }
                }
                else
                {
                    e.Value = filteredindexes[e.Row];
                }
            }
        }
    }

        private void c1TrueDBGrid1_MouseUp(object sender, MouseEventArgs e)
        {
            row = this.c1TrueDBGrid1.RowContaining(e.Y);
            this.c1TrueDBGrid1.Refresh();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (!filter)
            {
                c1TrueDBGrid1.AllowAddNew = true;
                c1TrueDBGrid1.MoveLast();
                c1TrueDBGrid1.Row = c1TrueDBGrid1.Row + 1;
                c1TrueDBGrid1.Select();
                c1TrueDBGrid1.Columns[1].Text = (c1TrueDBGrid1.Row + 1).ToString();
                c1TrueDBGrid1.Columns[2].Text = "Name" + c1TrueDBGrid1.RowCount.ToString();
                c1TrueDBGrid1.UpdateData();
            }
            else
                MessageBox.Show("Please remove the filter to add a row");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (!filter)
                c1TrueDBGrid1.Delete();
            else
                MessageBox.Show("Please remove the filter to delete a row");
        }

        private void c1TrueDBGrid1_AfterFilter(object sender, C1.Win.C1TrueDBGrid.FilterEventArgs e)
        {
            if (e.Condition != "")
            {
                filter = true;
                filindex = 0;
                filterdone = false;
                filteredindexes = new string[c1TrueDBGrid1.RowCount];

            }
            else
            {
                filter = false;
            }
            
        }

        private void c1TrueDBGrid1_BeforeColEdit(object sender, C1.Win.C1TrueDBGrid.BeforeColEditEventArgs e)
        {
            if (c1TrueDBGrid1.FilterActive && c1TrueDBGrid1.Columns[e.ColIndex].FilterText == "")
            {
                
                filtercol = new string[c1TrueDBGrid1.RowCount];
                rowindex = new string[c1TrueDBGrid1.RowCount];
                for (int r = 0; r < c1TrueDBGrid1.RowCount; r++)
                {
                    rowindex[r] = c1TrueDBGrid1[r, 0].ToString();
                    filtercol[r] = c1TrueDBGrid1[r,e.ColIndex].ToString();
                }
            }
        }
    }
}
